var _templateObject = _taggedTemplateLiteral(['\n  position: relative;\n  padding: ', '\n    ', ';\n\n  margin-bottom: ', ';\n\n  border: ', ' solid transparent;\n\n  a {\n    font-weight: ', ';\n  }\n\n  ', ';\n\n  ', '};\n'], ['\n  position: relative;\n  padding: ', '\n    ', ';\n\n  margin-bottom: ', ';\n\n  border: ', ' solid transparent;\n\n  a {\n    font-weight: ', ';\n  }\n\n  ', ';\n\n  ', '};\n']);

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import PropTypes from 'prop-types';
import styled from 'styled-components';
// $FlowIssue
import get from 'lodash.get';
import themeProp from '../utils/theme';

import { borderRadius } from '../utils/border-radius';
import { themeColorLevel } from '../utils/color-functions';

import { alertVariant } from './utils/alert-variant';

import * as defaultTheme from './default-theme';

var alertPaddingY = defaultTheme.alertPaddingY,
    alertPaddingX = defaultTheme.alertPaddingX,
    alertMarginBottom = defaultTheme.alertMarginBottom,
    alertBorderWidth = defaultTheme.alertBorderWidth,
    alertLinkFontWeight = defaultTheme.alertLinkFontWeight,
    alertBorderRadius = defaultTheme.alertBorderRadius,
    alertBgLevel = defaultTheme.alertBgLevel,
    alertBorderLevel = defaultTheme.alertBorderLevel,
    alertColorLevel = defaultTheme.alertColorLevel;


var Alert = styled.div(_templateObject, themeProp('alertPaddingY', alertPaddingY), themeProp('alertPaddingX,', alertPaddingX), themeProp('alertMarginBottom', alertMarginBottom), themeProp('alertBorderWidth', alertBorderWidth), themeProp('alertLinkFontWeight', alertLinkFontWeight), borderRadius(themeProp('alertBorderRadius', alertBorderRadius)), function (_ref) {
  var type = _ref.type,
      theme = _ref.theme;
  return alertVariant(themeColorLevel(defaultTheme[type], get(theme, 'alertBgLevel', alertBgLevel)), themeColorLevel(defaultTheme[type], get(theme, 'alertBorderLevel', alertBorderLevel)), themeColorLevel(defaultTheme[type], get(theme, 'alertColorLevel', alertColorLevel)));
});

Alert.defaultProps = {
  type: 'primary'
};

Alert.propTypes = {
  type: PropTypes.oneOf(['primary', 'secondary', 'success', 'danger', 'warning', 'info', 'light', 'dark'])
};

export default Alert;