import React, { Fragment } from 'react';
import { storiesOf } from '@storybook/react';
import { host } from 'storybook-host';

import Alert from '../index';

export default storiesOf('Alert', module).addDecorator(host({
  title: 'Provide contextual feedback messages for typical user actions with the handful of available and flexible alert messages.',
  align: 'center',
  width: 700
})).add('Default Alert', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      Alert,
      { type: 'primary' },
      'This is a primary alert\u2014check it out!'
    ),
    React.createElement(
      Alert,
      { type: 'secondary' },
      'This is a secondary alert\u2014check it out!'
    ),
    React.createElement(
      Alert,
      { type: 'success' },
      'This is a success alert\u2014check it out!'
    ),
    React.createElement(
      Alert,
      { type: 'danger' },
      'This is a danger alert\u2014check it out!'
    ),
    React.createElement(
      Alert,
      { type: 'warning' },
      'This is a warning alert\u2014check it out!'
    ),
    React.createElement(
      Alert,
      { type: 'info' },
      'This is a info alert\u2014check it out!'
    ),
    React.createElement(
      Alert,
      { type: 'light' },
      'This is a light alert\u2014check it out!'
    ),
    React.createElement(
      Alert,
      { type: 'dark' },
      'This is a dark alert\u2014check it out!'
    )
  );
});