var _templateObject = _taggedTemplateLiteral(['\n  position: absolute;\n  color: green;\n  top: 0;\n  right: 0;\n  padding: 0.75rem 1.25rem;\n'], ['\n  position: absolute;\n  color: green;\n  top: 0;\n  right: 0;\n  padding: 0.75rem 1.25rem;\n']);

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import React, { Fragment } from 'react';
import { storiesOf } from '@storybook/react';
import { host } from 'storybook-host';
import { action } from '@storybook/addon-actions';

import styled, { ThemeProvider } from 'styled-components';

import Alert, { DismissableAlert } from '../index';
import CloseIcon from '../../CLoseIcon';

var StyledCloseIcon = styled(CloseIcon)(_templateObject);

var customTheme = {
  alertPaddingY: '.5rem',
  alertPaddingX: '1rem',
  alertMarginBottom: '1rem',
  alertBorderRadius: '0.5rem',
  alertLinkFontWeight: 'normal',
  alertBorderWidth: '2px',

  alertBgLevel: -9,
  alertBorderLevel: -5,
  alertColorLevel: 3
};

var customButtonTheme = {
  closeFontWeight: 700,
  closeColor: 'red',
  closeTextShadow: '0 1px 0 blue'
};

export default storiesOf('Alert', module).addDecorator(host({
  align: 'center',
  width: 700
})).add('With custom Close Icon', function () {
  return React.createElement(
    ThemeProvider,
    { theme: customButtonTheme },
    React.createElement(
      Fragment,
      null,
      React.createElement(
        DismissableAlert,
        {
          type: 'primary',
          onClose: action('button-click'),
          closeIcon: React.createElement(StyledCloseIcon, null)
        },
        'This is a dark alert with ',
        React.createElement(
          'a',
          { href: '#' },
          'an example link'
        ),
        '. Give it a click if you like.'
      ),
      React.createElement(
        DismissableAlert,
        { type: 'warning', onClose: action('button-click') },
        'This is a dark alert with ',
        React.createElement(
          'a',
          { href: '#' },
          'an example link'
        ),
        '. Give it a click if you like.'
      )
    )
  );
}).add('With ThemeProvider', function () {
  return React.createElement(
    ThemeProvider,
    { theme: customTheme },
    React.createElement(
      Fragment,
      null,
      React.createElement(
        Alert,
        { type: 'primary' },
        'This is a primary alert\u2014check it out!'
      ),
      React.createElement(
        Alert,
        { type: 'secondary' },
        'This is a secondary alert\u2014check it out!'
      ),
      React.createElement(
        Alert,
        { type: 'success' },
        'This is a success alert\u2014check it out!'
      ),
      React.createElement(
        Alert,
        { type: 'danger' },
        'This is a danger alert\u2014check it out!'
      ),
      React.createElement(
        Alert,
        { type: 'warning' },
        'This is a warning alert\u2014check it out!'
      ),
      React.createElement(
        Alert,
        { type: 'info' },
        'This is a info alert\u2014check it out!'
      ),
      React.createElement(
        Alert,
        { type: 'light' },
        'This is a light alert\u2014check it out!'
      ),
      React.createElement(
        Alert,
        { type: 'dark' },
        'This is a dark alert\u2014check it out!'
      )
    )
  );
});