var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  .react-transition-exit {\n    opacity: 1;\n    height: 50px;\n    overflow: hidden;\n  }\n\n  .react-transition-exit.react-transition-exit-active {\n    height: 0;\n    opacity: 0;\n    transition: all .15s linear;\n  }\n'], ['\n  .react-transition-exit {\n    opacity: 1;\n    height: 50px;\n    overflow: hidden;\n  }\n\n  .react-transition-exit.react-transition-exit-active {\n    height: 0;\n    opacity: 0;\n    transition: all .15s linear;\n  }\n']);

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import React, { Component, Fragment } from 'react';
import { storiesOf } from '@storybook/react';
import { host } from 'storybook-host';

import { injectGlobal } from 'styled-components';

import { Transition, TransitionGroup, CSSTransition } from 'react-transition-group';

import { DismissableAlert } from '../index';

injectGlobal(_templateObject);

var transitionProps = {
  classNames: 'react-transition',
  timeout: { enter: 500, exit: 300 }
};

var DismissableAlertWrapper = function (_Component) {
  _inherits(DismissableAlertWrapper, _Component);

  function DismissableAlertWrapper(props, context) {
    _classCallCheck(this, DismissableAlertWrapper);

    var _this = _possibleConstructorReturn(this, (DismissableAlertWrapper.__proto__ || Object.getPrototypeOf(DismissableAlertWrapper)).call(this, props, context));

    _this.closeAlert = function (type) {
      _this.setState(_defineProperty({}, type, !_this.state[type]));
    };

    _this.state = {
      primary: true,
      secondary: true,
      success: true,
      danger: true,
      warning: true,
      info: true,
      light: true,
      dark: true
    };
    return _this;
  }

  _createClass(DismissableAlertWrapper, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return React.createElement(
        TransitionGroup,
        null,
        this.state.primary && React.createElement(
          CSSTransition,
          _extends({ key: 1 }, transitionProps),
          React.createElement(
            DismissableAlert,
            {
              type: 'primary',
              onClose: function onClose() {
                return _this2.closeAlert('primary');
              }
            },
            'This is a primary alert with ',
            React.createElement(
              'a',
              { href: '#' },
              'an example link'
            ),
            '. Give it a click if you like.'
          )
        ),
        this.state.secondary && React.createElement(
          CSSTransition,
          _extends({ key: 2 }, transitionProps),
          React.createElement(
            DismissableAlert,
            {
              type: 'secondary',
              onClose: function onClose() {
                return _this2.closeAlert('secondary');
              }
            },
            'This is a secondary alert with ',
            React.createElement(
              'a',
              { href: '#' },
              'an example link'
            ),
            '. Give it a click if you like.'
          )
        ),
        this.state.success && React.createElement(
          CSSTransition,
          _extends({ key: 3 }, transitionProps),
          React.createElement(
            DismissableAlert,
            {
              type: 'success',
              onClose: function onClose() {
                return _this2.closeAlert('success');
              }
            },
            'This is a success alert with ',
            React.createElement(
              'a',
              { href: '#' },
              'an example link'
            ),
            '. Give it a click if you like.'
          )
        ),
        this.state.danger && React.createElement(
          CSSTransition,
          _extends({ key: 4 }, transitionProps),
          React.createElement(
            DismissableAlert,
            {
              type: 'danger',
              onClose: function onClose() {
                return _this2.closeAlert('danger');
              }
            },
            'This is a danger alert with ',
            React.createElement(
              'a',
              { href: '#' },
              'an example link'
            ),
            '. Give it a click if you like.'
          )
        ),
        this.state.warning && React.createElement(
          CSSTransition,
          _extends({ key: 5 }, transitionProps),
          React.createElement(
            DismissableAlert,
            {
              type: 'warning',
              onClose: function onClose() {
                return _this2.closeAlert('warning');
              }
            },
            'This is a warning alert with ',
            React.createElement(
              'a',
              { href: '#' },
              'an example link'
            ),
            '. Give it a click if you like.'
          )
        ),
        this.state.info && React.createElement(
          CSSTransition,
          _extends({ key: 6 }, transitionProps),
          React.createElement(
            DismissableAlert,
            {
              type: 'info',
              onClose: function onClose() {
                return _this2.closeAlert('info');
              }
            },
            'This is a info alert with ',
            React.createElement(
              'a',
              { href: '#' },
              'an example link'
            ),
            '. Give it a click if you like.'
          )
        ),
        this.state.light && React.createElement(
          CSSTransition,
          _extends({ key: 7 }, transitionProps),
          React.createElement(
            DismissableAlert,
            {
              type: 'light',
              onClose: function onClose() {
                return _this2.closeAlert('light');
              }
            },
            'This is a light alert with ',
            React.createElement(
              'a',
              { href: '#' },
              'an example link'
            ),
            '. Give it a click if you like.'
          )
        ),
        this.state.dark && React.createElement(
          CSSTransition,
          _extends({ key: 8 }, transitionProps),
          React.createElement(
            DismissableAlert,
            {
              type: 'dark',
              onClose: function onClose() {
                return _this2.closeAlert('dark');
              }
            },
            'This is a dark alert with ',
            React.createElement(
              'a',
              { href: '#' },
              'an example link'
            ),
            '. Give it a click if you like.'
          )
        )
      );
    }
  }]);

  return DismissableAlertWrapper;
}(Component);

export default storiesOf('Alert', module).addDecorator(host({
  title: 'A host container for components under test.',
  align: 'center',
  width: 700
})).add('Dismissable Alert', function () {
  return React.createElement(DismissableAlertWrapper, null);
});