import React, { Fragment } from 'react';
import { storiesOf } from '@storybook/react';
import { host } from 'storybook-host';

import { ThemeProvider } from 'styled-components';

import Badge from '../Badge';

var customTheme = {
  badgeFontWeight: 400,
  badgePaddingY: '.23em',
  badgePaddingX: '.5em',
  badgeBorderRadius: '0'
};

var margin = { marginRight: 6, marginBottom: 6 };

export default storiesOf('Badge', module).addDecorator(host({
  title: 'Small count and labeling component.',
  align: 'center'
})).add('Badges', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      'h1',
      null,
      'Example heading ',
      React.createElement(
        Badge,
        { color: 'secondary' },
        'New'
      )
    ),
    React.createElement(
      'h2',
      null,
      'Example heading ',
      React.createElement(
        Badge,
        { color: 'secondary' },
        'New'
      )
    ),
    React.createElement(
      'h3',
      null,
      'Example heading ',
      React.createElement(
        Badge,
        { color: 'secondary' },
        'New'
      )
    ),
    React.createElement(
      'h4',
      null,
      'Example heading ',
      React.createElement(
        Badge,
        { color: 'secondary' },
        'New'
      )
    ),
    React.createElement(
      'h5',
      null,
      'Example heading ',
      React.createElement(
        Badge,
        { color: 'secondary' },
        'New'
      )
    ),
    React.createElement(
      'h6',
      null,
      'Example heading ',
      React.createElement(
        Badge,
        { color: 'secondary' },
        'New'
      )
    )
  );
}).add('Color Badges', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      Badge,
      { style: margin, color: 'primary' },
      'Primary'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'secondary' },
      'Secondary'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'success' },
      'Success'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'danger' },
      'Danger'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'warning' },
      'Warning'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'info' },
      'Info'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'light' },
      'Light'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'dark' },
      'Dark'
    )
  );
}).add('Link Badges', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      Badge.Link,
      { href: '#', style: margin, color: 'primary' },
      'Primary'
    ),
    React.createElement(
      Badge.Link,
      { href: '#', style: margin, color: 'secondary' },
      'Secondary'
    ),
    React.createElement(
      Badge.Link,
      { href: '#', style: margin, color: 'success' },
      'Success'
    ),
    React.createElement(
      Badge.Link,
      { href: '#', style: margin, color: 'danger' },
      'Danger'
    ),
    React.createElement(
      Badge.Link,
      { href: '#', style: margin, color: 'warning' },
      'Warning'
    ),
    React.createElement(
      Badge.Link,
      { href: '#', style: margin, color: 'info' },
      'Info'
    ),
    React.createElement(
      Badge.Link,
      { href: '#', style: margin, color: 'light' },
      'Light'
    ),
    React.createElement(
      Badge.Link,
      { href: '#', style: margin, color: 'dark' },
      'Dark'
    )
  );
}).add('Pill Badges', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      Badge,
      { style: margin, color: 'primary', pill: true },
      'Primary'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'secondary', pill: true },
      'Secondary'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'success', pill: true },
      'Success'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'info', pill: true },
      'Info'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'warning', pill: true },
      'Warning'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'danger', pill: true },
      'Danger'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'light', pill: true },
      'Light'
    ),
    React.createElement(
      Badge,
      { style: margin, color: 'dark', pill: true },
      'Dark'
    )
  );
}).add('Squared badges', function () {
  return React.createElement(
    ThemeProvider,
    { theme: customTheme },
    React.createElement(
      Fragment,
      null,
      React.createElement(
        Badge,
        { style: margin, color: 'primary' },
        'Primary'
      ),
      React.createElement(
        Badge,
        { style: margin, color: 'secondary' },
        'Secondary'
      ),
      React.createElement(
        Badge,
        { style: margin, color: 'success' },
        'Success'
      ),
      React.createElement(
        Badge,
        { style: margin, color: 'info' },
        'Info'
      ),
      React.createElement(
        Badge,
        { style: margin, color: 'warning' },
        'Warning'
      ),
      React.createElement(
        Badge,
        { style: margin, color: 'danger' },
        'Danger'
      ),
      React.createElement(
        Badge,
        { style: margin, color: 'light' },
        'Light'
      ),
      React.createElement(
        Badge,
        { style: margin, color: 'dark' },
        'Dark'
      )
    )
  );
});