import React, { Fragment } from 'react';
import { storiesOf } from '@storybook/react';
import { host } from 'storybook-host';

// import extend, { ThemeProvider } from 'styled-components';

import Breadcrumb from '../Breadcrumb';

var customTheme = {
  closeFontSize: '1.75rem',
  closeFontWeight: 700,
  closeColor: 'red',
  closeTextShadow: '0 1px 0 blue'
};

export default storiesOf('Breadcrumb', module).addDecorator(host({
  title: 'Indicate the current pages location within a navigational hierarchy.',
  align: 'center'
})).add('Breadcrumb', function () {
  return React.createElement(
    Breadcrumb,
    null,
    React.createElement(
      Breadcrumb.Item,
      null,
      React.createElement(
        'a',
        { href: '#' },
        'Home'
      )
    ),
    React.createElement(
      Breadcrumb.Item,
      null,
      React.createElement(
        'a',
        { href: '#' },
        'Library'
      )
    ),
    React.createElement(
      Breadcrumb.Item,
      { active: true },
      'Data'
    )
  );
});