var _templateObject = _taggedTemplateLiteral(['\n  display: ', ';\n  width: ', ';\n  font-weight: ', ';\n  text-align: center;\n  white-space: nowrap;\n  vertical-align: middle;\n  user-select: none;\n  border: ', ' solid transparent;\n\n  ', ';\n\n  /* Share hover and focus styles */\n  ', ';\n\n  &:focus,\n  &.focus {\n    outline: 0;\n    box-shadow: ', ';\n  }\n\n  &.disabled,\n  &:disabled {\n    opacity: ', ';\n    ', ';\n  }\n\n  /* Opinionated: add "hand" cursor to non-disabled .btn elements */\n  &:not(:disabled):not(.disabled) {\n    cursor: pointer;\n  }\n\n  ', ';\n\n  ', ';\n\n  ', ';\n\n  ', ';\n\n  ', ';\n\n  ', ';\n\n  ', ';\n'], ['\n  display: ', ';\n  width: ', ';\n  font-weight: ', ';\n  text-align: center;\n  white-space: nowrap;\n  vertical-align: middle;\n  user-select: none;\n  border: ', ' solid transparent;\n\n  ', ';\n\n  /* Share hover and focus styles */\n  ', ';\n\n  &:focus,\n  &.focus {\n    outline: 0;\n    box-shadow: ', ';\n  }\n\n  &.disabled,\n  &:disabled {\n    opacity: ', ';\n    ', ';\n  }\n\n  /* Opinionated: add "hand" cursor to non-disabled .btn elements */\n  &:not(:disabled):not(.disabled) {\n    cursor: pointer;\n  }\n\n  ', ';\n\n  ', ';\n\n  ', ';\n\n  ', ';\n\n  ', ';\n\n  ', ';\n\n  ', ';\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n      font-weight: ', ';\n      color: ', ';\n      background-color: transparent;\n\n\n\n      ', ';\n\n      &:focus,\n      &.focus {\n        text-decoration: ', ';\n        border-color: transparent;\n        box-shadow: none;\n      }\n\n      &:disabled,\n      &.disabled {\n        color: text-decoration: ', ';\n      }\n    '], ['\n      font-weight: ', ';\n      color: ', ';\n      background-color: transparent;\n\n\n\n      ', ';\n\n      &:focus,\n      &.focus {\n        text-decoration: ', ';\n        border-color: transparent;\n        box-shadow: none;\n      }\n\n      &:disabled,\n      &.disabled {\n        color: text-decoration: ', ';\n      }\n    ']),
    _templateObject3 = _taggedTemplateLiteral(['\n        color: ', ';\n        text-decoration: ', ';\n        background-color: transparent;\n        border-color: transparent;\n      '], ['\n        color: ', ';\n        text-decoration: ', ';\n        background-color: transparent;\n        border-color: transparent;\n      ']),
    _templateObject4 = _taggedTemplateLiteral(['\n      background-image: none;\n      ', ';\n    '], ['\n      background-image: none;\n      ', ';\n    ']);

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import styled, { css } from 'styled-components';
import PropTypes from 'prop-types';

import themeProp from '../utils/theme';

import { boxShadow } from '../utils/box-shadow';
import { hover, hoverFocus } from '../utils/hover';
import { transition } from '../utils/transition';

import { buttonVariant } from './utils/button-variant';
import { buttonSize } from './utils/button-size';
import { buttonOutlineVariant } from './utils/button-outline-variant';

import * as defaultTheme from './defaultTheme';

var enableShadows = defaultTheme.enableShadows,
    btnBoxShadow = defaultTheme.btnBoxShadow,
    btnBorderWidth = defaultTheme.btnBorderWidth,
    btnFocusBoxShadow = defaultTheme.btnFocusBoxShadow,
    btnDisabledOpacity = defaultTheme.btnDisabledOpacity,
    btnPaddingY = defaultTheme.btnPaddingY,
    btnPaddingX = defaultTheme.btnPaddingX,
    fontSizeBase = defaultTheme.fontSizeBase,
    btnLineHeight = defaultTheme.btnLineHeight,
    btnBorderRadius = defaultTheme.btnBorderRadius,
    btnPaddingYlg = defaultTheme.btnPaddingYlg,
    btnPaddingXlg = defaultTheme.btnPaddingXlg,
    fontSizeLg = defaultTheme.fontSizeLg,
    btnLineHeightLg = defaultTheme.btnLineHeightLg,
    btnBorderRadiusLg = defaultTheme.btnBorderRadiusLg,
    btnPaddingYsm = defaultTheme.btnPaddingYsm,
    btnPaddingXsm = defaultTheme.btnPaddingXsm,
    fontSizeSm = defaultTheme.fontSizeSm,
    btnLineHeightSm = defaultTheme.btnLineHeightSm,
    btnBorderRadiusSm = defaultTheme.btnBorderRadiusSm,
    btnTransition = defaultTheme.btnTransition;


var Button = styled.button(_templateObject, function (_ref) {
  var block = _ref.block;
  return block ? 'block' : 'inline-block';
}, function (_ref2) {
  var block = _ref2.block;
  return block && '100%';
}, themeProp('btnFontWeight'), themeProp('btnBorderWidth', btnBorderWidth), transition(themeProp('btnTransition', btnTransition)), hoverFocus('text-decoration: none;'), themeProp('btnFocusBoxShadow', btnFocusBoxShadow), themeProp('btnDisabledOpacity', btnDisabledOpacity), boxShadow('none'), function (_ref3) {
  var theme = _ref3.theme,
      color = _ref3.color;
  return color !== 'link' && buttonVariant(theme[color] || defaultTheme[color], theme[color] || defaultTheme[color], theme.enableShadows || enableShadows, theme.btnBoxShadow || btnBoxShadow, theme.btnActiveBoxShadow);
}, function (_ref4) {
  var color = _ref4.color;
  return color === 'link' && css(_templateObject2, themeProp('fontWeightNormal', 'normal'), themeProp('linkColor', '#007bff'), hover(css(_templateObject3, themeProp('linkHoverColor', '#0056b3'), themeProp('linkHoverDecoration', 'underline'))), themeProp('linkHoverDecoration', 'underline'), themeProp('btnLinkDisabledColor', '#6c757d'));
}, function (_ref5) {
  var theme = _ref5.theme,
      outline = _ref5.outline,
      color = _ref5.color;
  return outline && buttonOutlineVariant(theme[color] || defaultTheme[color]);
}, function (_ref6) {
  var size = _ref6.size,
      theme = _ref6.theme;
  return size === 'normal' && buttonSize(themeProp('btnPaddingY', btnPaddingY), themeProp('btnPaddingX', btnPaddingX), themeProp('fontSizeBase', fontSizeBase), themeProp('btnLineHeight', btnLineHeight), typeof theme.enableRounded === 'undefined' ? themeProp('btnBorderRadius', btnBorderRadius) : 0);
}, function (_ref7) {
  var size = _ref7.size,
      theme = _ref7.theme;
  return size === 'small' && buttonSize(themeProp('btnPaddingYsm', btnPaddingYsm), themeProp('btnPaddingXsm', btnPaddingXsm), themeProp('fontSizeSm', fontSizeSm), themeProp('btnLineHeightSm', btnLineHeightSm), typeof theme.enableRounded === 'undefined' ? themeProp('btnBorderRadiusSm', btnBorderRadiusSm) : 0);
}, function (_ref8) {
  var size = _ref8.size,
      theme = _ref8.theme;
  return size === 'large' && buttonSize(themeProp('btnPaddingYlg', btnPaddingYlg), themeProp('btnPaddingXlg', btnPaddingXlg), themeProp('fontSizeLg', fontSizeLg), themeProp('btnLineHeightLg', btnLineHeightLg), typeof theme.enableRounded === 'undefined' ? themeProp('btnBorderRadiusLg', btnBorderRadiusLg) : 0);
}, function (_ref9) {
  var active = _ref9.active;
  return active && css(_templateObject4, boxShadow(themeProp('btnFocusBoxShadow', btnFocusBoxShadow)));
});

Button.Link = Button.withComponent('a');

Button.defaultProps = {
  active: false,
  block: false,
  color: 'primary',
  size: 'normal',
  outline: false
};

Button.propTypes = {
  active: PropTypes.bool,
  block: PropTypes.bool,
  color: PropTypes.string,
  size: PropTypes.string,
  outline: PropTypes.bool
};

export default Button;