import React, { Fragment } from 'react';
import { storiesOf } from '@storybook/react';
import { host } from 'storybook-host';
import { ThemeProvider } from 'styled-components';

import Button from '../Button';

var margin = { marginRight: 6, marginBottom: 6 };

export default storiesOf('Buttons', module).addDecorator(host({
  align: 'center',
  width: 460
})).add('Basic Buttons', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      Button,
      { style: margin, color: 'primary' },
      'Primary'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'secondary' },
      'Secondary'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'success' },
      'Success'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'warning' },
      'Warning'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'danger' },
      'Danger'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'info' },
      'Info'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'light' },
      'Light'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'dark' },
      'Dark'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'link' },
      'Link'
    )
  );
}).add('Outline Buttons', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      Button,
      { style: margin, color: 'primary', outline: true },
      'Primary'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'secondary', outline: true },
      'Secondary'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'success', outline: true },
      'Success'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'warning', outline: true },
      'Warning'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'danger', outline: true },
      'Danger'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'info', outline: true },
      'Info'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'light', outline: true },
      'Light'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'dark', outline: true },
      'Dark'
    )
  );
}).add('Disabled Buttons', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      Button,
      { style: margin, color: 'primary', disabled: true },
      'Primary'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'secondary', disabled: true },
      'Secondary'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'success', disabled: true },
      'Success'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'warning', disabled: true },
      'Warning'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'danger', disabled: true },
      'Danger'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'info', disabled: true },
      'Info'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'light', disabled: true },
      'Light'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'dark', disabled: true },
      'Dark'
    )
  );
}).add('Large Buttons', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      Button,
      { style: margin, color: 'primary', size: 'large' },
      'Primary'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'secondary', size: 'large' },
      'Secondary'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'success', size: 'large' },
      'Success'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'warning', size: 'large' },
      'Warning'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'danger', size: 'large' },
      'Danger'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'info', size: 'large' },
      'Info'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'light', size: 'large' },
      'Light'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'dark', size: 'large' },
      'Dark'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'link', size: 'large' },
      'Link'
    )
  );
}).add('Small Buttons', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      Button,
      { style: margin, color: 'primary', size: 'small' },
      'Primary'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'secondary', size: 'small' },
      'Secondary'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'success', size: 'small' },
      'Success'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'warning', size: 'small' },
      'Warning'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'danger', size: 'small' },
      'Danger'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'info', size: 'small' },
      'Info'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'light', size: 'small' },
      'Light'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'dark', size: 'small' },
      'Dark'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'link', size: 'small' },
      'Link'
    )
  );
}).add('Block Buttons', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      Button,
      { style: margin, color: 'primary', block: true },
      'Primary'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'secondary', block: true },
      'Secondary'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'success', block: true },
      'Success'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'warning', block: true },
      'Warning'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'danger', block: true },
      'Danger'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'info', block: true },
      'Info'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'light', block: true },
      'Light'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'dark', block: true },
      'Dark'
    ),
    React.createElement(
      Button,
      { style: margin, color: 'link', block: true },
      'Link'
    )
  );
}).add('Link Buttons', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      Button.Link,
      { style: margin, color: 'primary', href: '#' },
      'Primary'
    ),
    React.createElement(
      Button.Link,
      { style: margin, color: 'secondary', href: '#' },
      'Secondary'
    ),
    React.createElement(
      Button.Link,
      { style: margin, color: 'success', href: '#' },
      'Success'
    ),
    React.createElement(
      Button.Link,
      { style: margin, color: 'warning', href: '#' },
      'Warning'
    ),
    React.createElement(
      Button.Link,
      { style: margin, color: 'danger', href: '#' },
      'Danger'
    ),
    React.createElement(
      Button.Link,
      { style: margin, color: 'info', href: '#' },
      'Info'
    ),
    React.createElement(
      Button.Link,
      { style: margin, color: 'light', href: '#' },
      'Light'
    ),
    React.createElement(
      Button.Link,
      { style: margin, color: 'dark', href: '#' },
      'Dark'
    ),
    React.createElement(
      Button.Link,
      { style: margin, color: 'link', href: '#' },
      'Link'
    )
  );
}).add('Custom Buttons', function () {
  return React.createElement(
    ThemeProvider,
    {
      theme: {
        enableRounded: false,
        primary: 'SkyBlue',
        secondary: 'gray',
        success: 'YellowGreen',
        info: 'PowderBlue',
        warning: 'GoldenRod',
        danger: 'FireBrick',
        light: 'ghostWhite',
        dark: 'black',
        linkColor: 'LightSkyBlue',
        linkHoverColor: 'LightCoral'
      }
    },
    React.createElement(
      Fragment,
      null,
      React.createElement(
        Button,
        { style: margin, color: 'primary', href: '#' },
        'Primary'
      ),
      React.createElement(
        Button,
        { style: margin, color: 'secondary', href: '#' },
        'Secondary'
      ),
      React.createElement(
        Button,
        { style: margin, color: 'success', href: '#' },
        'Success'
      ),
      React.createElement(
        Button,
        { style: margin, color: 'warning', href: '#' },
        'Warning'
      ),
      React.createElement(
        Button,
        { style: margin, color: 'danger', href: '#' },
        'Danger'
      ),
      React.createElement(
        Button,
        { style: margin, color: 'info', href: '#' },
        'Info'
      ),
      React.createElement(
        Button,
        { style: margin, color: 'light', href: '#' },
        'Light'
      ),
      React.createElement(
        Button,
        { style: margin, color: 'dark', href: '#' },
        'Dark'
      ),
      React.createElement(
        Button,
        { style: margin, color: 'link', href: '#' },
        'Link'
      )
    )
  );
});