var _templateObject = _taggedTemplateLiteral(['\n    color: ', ';\n    background-color: ', ';\n    border-color: ', ';\n\n    ', ';\n\n    ', ';\n\n    &:focus,\n    &.focus {\n      /* Avoid using mixin so we can pass custom focus shadow properly */\n      ', ';\n    }\n\n    // Disabled comes first so active can properly restyle\n    &.disabled,\n    &:disabled {\n      background-color: ', ';\n      border-color: ', ';\n    }\n\n    &:active,\n    &.active,\n    .show > &.dropdown-toggle {\n      background-color: ', ';\n      background-image: none;\n      border-color: ', ';\n      ', ';\n    }\n  '], ['\n    color: ', ';\n    background-color: ', ';\n    border-color: ', ';\n\n    ', ';\n\n    ', ';\n\n    &:focus,\n    &.focus {\n      /* Avoid using mixin so we can pass custom focus shadow properly */\n      ', ';\n    }\n\n    // Disabled comes first so active can properly restyle\n    &.disabled,\n    &:disabled {\n      background-color: ', ';\n      border-color: ', ';\n    }\n\n    &:active,\n    &.active,\n    .show > &.dropdown-toggle {\n      background-color: ', ';\n      background-image: none;\n      border-color: ', ';\n      ', ';\n    }\n  ']),
    _templateObject2 = _taggedTemplateLiteral(['\n      color: ', ';\n      ', ';\n      border-color: ', ';\n    '], ['\n      color: ', ';\n      ', ';\n      border-color: ', ';\n    ']);

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import { css } from 'styled-components';
// $FlowIssue
import darken from 'polished/lib/color/darken';

import { colorYiq } from '../../utils/color-functions';
import { boxShadow } from '../../utils/box-shadow';
import { gradientBg } from '../../utils/gradients';
import { sassRgba } from '../../utils/sassRgba';
import { hover } from '../../utils/hover';

export function buttonVariant(background, border, enableShadows, btnBoxShadow, btnActiveBoxShadow) {
  var hoverBackground = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : darken(0.075, background);
  var hoverBorder = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : darken(0.1, border);
  var activeBackground = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : darken(0.1, background);
  var activeBorder = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : darken(0.125, border);

  return css(_templateObject, colorYiq(background), background, border, boxShadow(btnBoxShadow), hover(css(_templateObject2, colorYiq(hoverBackground), gradientBg(hoverBackground), hoverBorder)), enableShadows ? 'box-shadow: ' + btnBoxShadow + ', 0 0 0 3px ' + sassRgba(border, 0.5) + ';' : 'box-shadow: 0 0 0 3px ' + sassRgba(border, 0.5) + ';', background, border, activeBackground, activeBorder, boxShadow(btnActiveBoxShadow));
}

export default buttonVariant;