var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  ', ';\n  ', ';\n\n  ', ';\n'], ['\n  ', ';\n  ', ';\n\n  ', ';\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n      height: 0;\n      overflow: hidden;\n      transition: ', ';\n    '], ['\n      height: 0;\n      overflow: hidden;\n      transition: ', ';\n    ']);

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Transition from 'react-transition-group/Transition';
import omit from 'lodash.omit';
import styled, { css } from 'styled-components';

import themeProp from '../utils/theme';
import transitionCollapse from './default-theme';

var Wrapper = styled.div(_templateObject, function (_ref) {
  var status = _ref.status;
  return status === 'exited' && 'display: none;';
}, function (_ref2) {
  var status = _ref2.status;
  return status === 'entered' && 'display: block;';
}, function (_ref3) {
  var status = _ref3.status;
  return (status === 'exiting' || status === 'entering') && css(_templateObject2, themeProp('transitionCollapse', transitionCollapse));
});

var TransitionTimeouts = {
  Fade: 150, // $transition-fade
  Collapse: 350, // $transition-collapse
  Modal: 300, // $modal-transition
  Carousel: 600 // $carousel-transition
};

// Duplicated Transition.propType keys to ensure that Reactstrap builds
// for distribution properly exclude these keys for nested child HTML attributes
// since `react-transition-group` removes propTypes in production builds.
var TransitionPropTypeKeys = ['in', 'mountOnEnter', 'unmountOnExit', 'appear', 'enter', 'exit', 'timeout', 'onEnter', 'onEntering', 'onEntered', 'onExit', 'onExiting', 'onExited'];

function getHeight(node) {
  return node.scrollHeight;
}

var Collapse = function (_Component) {
  _inherits(Collapse, _Component);

  function Collapse(props) {
    _classCallCheck(this, Collapse);

    var _this = _possibleConstructorReturn(this, (Collapse.__proto__ || Object.getPrototypeOf(Collapse)).call(this, props));

    _this.onEntering = function (node) {
      _this.setState({ height: getHeight(node) });
      _this.props.onEntering();
    };

    _this.onEntered = function () {
      _this.setState({ height: null });
      _this.props.onEntered();
    };

    _this.onExit = function (node) {
      _this.setState({ height: getHeight(node) });
      _this.props.onExit();
    };

    _this.onExiting = function (node) {
      var unused = node.offsetHeight; // eslint-disable-line no-unused-vars
      _this.setState({ height: 0 });
      _this.props.onExiting();
    };

    _this.onExited = function () {
      _this.setState({ height: null });
      _this.props.onExited();
    };

    _this.state = {
      height: null
    };
    return _this;
  }

  _createClass(Collapse, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          isOpen = _props.isOpen,
          children = _props.children,
          otherProps = _objectWithoutProperties(_props, ['isOpen', 'children']);

      var height = this.state.height;


      var childProps = omit(otherProps, TransitionPropTypeKeys);

      return React.createElement(
        Transition,
        _extends({}, this.props, {
          'in': isOpen,
          onEntering: this.onEntering,
          onEntered: this.onEntered,
          onExit: this.onExit,
          onExiting: this.onExiting,
          onExited: this.onExited
        }),
        function (status) {
          var style = height === null ? null : { height: height };
          return React.createElement(
            Wrapper,
            _extends({ status: status, style: _extends({}, style) }, childProps),
            children
          );
        }
      );
    }
  }]);

  return Collapse;
}(Component);

Collapse.defaultProps = _extends({}, Transition.defaultProps, {
  isOpen: false,
  timeout: TransitionTimeouts.Collapse
});

Collapse.propTypes = _extends({}, Transition.propTypes, {
  isOpen: PropTypes.bool,
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
});

export default Collapse;