var _templateObject = _taggedTemplateLiteral(['\n  &:not([size]):not([multiple]) {\n    ', '\n\n  &:focus::-ms-value {\n    // Suppress the nested default white text on blue background highlight given to\n    // the selected option text when the (still closed) <select> receives focus\n    // in IE and (under certain conditions) Edge, as it looks bad and cannot be made to\n    // match the appearance of the native widget.\n    // See https://github.com/twbs/bootstrap/issues/19398.\n    color: ', ';\n    background-color: ', ';\n  }\n'], ['\n  &:not([size]):not([multiple]) {\n    ', '\n\n  &:focus::-ms-value {\n    // Suppress the nested default white text on blue background highlight given to\n    // the selected option text when the (still closed) <select> receives focus\n    // in IE and (under certain conditions) Edge, as it looks bad and cannot be made to\n    // match the appearance of the native widget.\n    // See https://github.com/twbs/bootstrap/issues/19398.\n    color: ', ';\n    background-color: ', ';\n  }\n']);

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import stripUnit from 'polished/lib/helpers/stripUnit';

import Input from './Input';

import { inputBtnPaddingY, inputBtnPaddingX, fontSizeBase, inputBtnLineHeight, inputColor, inputBg, inputBtnBorderWidth, inputBorderColor, enableRounded, inputBorderRadius, inputTransition, inputBoxShadow, inputColorPlaceholder, inputBgDisabled, inputHeight } from '../../defaultTheme';

var Select = Input.withComponent('select').extend(_templateObject, function (props) {
  return 'height: calc(' + props.theme.inputHeight + ' + ' + stripUnit(props.theme.inputBtnBorderWidth) * 2 + 'px);';
}, function (props) {
  return props.theme.inputColor;
}, function (props) {
  return props.theme.inputBg;
});

Select.defaultProps = {
  theme: {
    inputBtnPaddingY: inputBtnPaddingY,
    inputBtnPaddingX: inputBtnPaddingX,
    fontSizeBase: fontSizeBase,
    inputBtnLineHeight: inputBtnLineHeight,
    inputColor: inputColor,
    inputBg: inputBg,
    inputBtnBorderWidth: inputBtnBorderWidth,
    inputBorderColor: inputBorderColor,
    enableRounded: enableRounded,
    inputBorderRadius: inputBorderRadius,
    inputTransition: inputTransition,
    inputBoxShadow: inputBoxShadow,
    inputColorPlaceholder: inputColorPlaceholder,
    inputBgDisabled: inputBgDisabled,
    inputHeight: inputHeight
  }
};

export default Select;