var _templateObject = _taggedTemplateLiteral(['\n  input,\n  button,\n  select,\n  optgroup,\n  textarea {\n    margin: 0;\n    font-family: inherit;\n    font-size: inherit;\n    line-height: inherit;\n  }\n'], ['\n  input,\n  button,\n  select,\n  optgroup,\n  textarea {\n    margin: 0;\n    font-family: inherit;\n    font-size: inherit;\n    line-height: inherit;\n  }\n']);

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import React, { Fragment } from 'react';
import { storiesOf } from '@storybook/react';
import { host } from 'storybook-host';
import { ThemeProvider, injectGlobal } from 'styled-components';

import Input from '../Input';
// import Select from '../Select';
// import Textarea from '../Textarea';

var customInputTheme = {
  enableRounded: false,
  inputFocusColor: 'SkyBlue',
  inputFocusBorderColor: 'PowderBlue',
  inputFocusBoxShadow: '0 0 0 4px azure'
};

injectGlobal(_templateObject);

export default storiesOf('Forms', module).addDecorator(host({
  title: 'Provide contextual feedback messages for typical user actions with the handful of available and flexible alert messages.',
  align: 'center',
  width: 700
})).add('Input', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      'label',
      { htmlFor: 'exampleInputText' },
      'Example text'
    ),
    React.createElement(Input, {
      name: 'exampleInputText',
      type: 'text',
      placeholder: 'Example text',
      id: 'exampleInputText'
    })
  );
}).add('Input Small', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      'label',
      { htmlFor: 'exampleInputText' },
      'Example text'
    ),
    React.createElement(Input, {
      size: 'small',
      type: 'text',
      placeholder: 'Example text',
      id: 'exampleInputText'
    })
  );
}).add('Input Large', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      'label',
      { htmlFor: 'exampleInputText' },
      'Example text'
    ),
    React.createElement(Input, {
      size: 'large',
      type: 'text',
      placeholder: 'Example text',
      id: 'exampleInputText'
    })
  );
}).add('Custom text input', function () {
  return React.createElement(
    ThemeProvider,
    { theme: customInputTheme },
    React.createElement(
      Fragment,
      null,
      React.createElement(
        'label',
        { htmlFor: 'exampleInputText2' },
        'Custom Text Input'
      ),
      React.createElement(Input, { type: 'text', placeholder: 'Enter email', id: 'exampleInputText2' })
    )
  );
});
// .add('Select', () => (
//   <div style={{ width: 400 }}>
//     <label htmlFor="exampleSelect1">Example select</label>
//     <Select id="exampleSelect1">
//       <option>1</option>
//       <option>2</option>
//       <option>3</option>
//       <option>4</option>
//       <option>5</option>
//     </Select>
//   </div>
// ))
// .add('Textarea', () => (
//   <div style={{ width: 400 }}>
//     <label htmlFor="exampleTextarea">Example textarea</label>
//     <Textarea id="exampleTextarea" rows="3" />
//   </div>
// ))
// .add('Full form', () => (
//   <form style={{ width: 625 }}>
//     <div className="form-group">
//       <label htmlFor="exampleFormControlInput1">Email address</label>
//       <Input
//         type="email"
//         placeholder="name@example.com"
//         id="exampleFormControlInput1"
//       />
//     </div>
//     <div className="form-group">
//       <label htmlFor="exampleFormControlSelect1">Example select</label>
//       <Select id="exampleFormControlSelect1">
//         <option>1</option>
//         <option>2</option>
//         <option>3</option>
//         <option>4</option>
//         <option>5</option>
//       </Select>
//     </div>
//     <div className="form-group">
//       <label htmlFor="exampleFormControlSelect2">
//         Example multiple select
//       </label>
//       <Select multiple id="exampleFormControlSelect2">
//         <option>1</option>
//         <option>2</option>
//         <option>3</option>
//         <option>4</option>
//         <option>5</option>
//       </Select>
//     </div>
//     <div className="form-group">
//       <label htmlFor="exampleFormControlTextarea1">Example textarea</label>
//       <Textarea id="exampleFormControlTextarea1" rows="3" />
//     </div>
//   </form>
// ));