var _templateObject = _taggedTemplateLiteral(['\n  margin-bottom: ', ';\n  font-family: ', ';\n\n  font-weight: ', ';\n  line-height: ', ';\n  color: ', ';\n\n  ', ';\n'], ['\n  margin-bottom: ', ';\n  font-family: ', ';\n\n  font-weight: ', ';\n  line-height: ', ';\n  color: ', ';\n\n  ', ';\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n      font-size: ', ';\n    '], ['\n      font-size: ', ';\n    ']);

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import { createElement } from 'react';
import PropTypes from 'prop-types';
import styled, { css } from 'styled-components';
import omit from 'lodash.omit';

import themeProp from '../utils/theme';

import * as defaultTheme from './default-theme';

var headingsMarginBottom = defaultTheme.headingsMarginBottom,
    headingsFontFamily = defaultTheme.headingsFontFamily,
    headingsFontWeight = defaultTheme.headingsFontWeight,
    headingsLineHeight = defaultTheme.headingsLineHeight,
    headingsColor = defaultTheme.headingsColor;


var Element = function Element(_ref) {
  var as = _ref.as,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['as', 'children']);

  return createElement(as, omit(props, ['as', 'size']), children);
};

var Heading = styled(Element)(_templateObject, themeProp('headingsMarginBottom', headingsMarginBottom), themeProp('headingsFontFamily', headingsFontFamily), themeProp('headingsFontWeight', headingsFontWeight), themeProp('headingsLineHeight', headingsLineHeight), themeProp('headingsColor', headingsColor), function (props) {
  var size = props.size || props.as;

  return css(_templateObject2, themeProp(size + 'FontSize', defaultTheme[size + 'FontSize']));
});

Heading.defaultProps = {
  as: 'h1'
};

Heading.proptypes = {
  as: PropTypes.oneOf(['h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'span', 'p']),
  size: PropTypes.oneOf(['h1', 'h2', 'h3', 'h4', 'h5', 'h6'])
};

export default Heading;