import React, { Fragment } from 'react';
import { storiesOf } from '@storybook/react';
import { host } from 'storybook-host';

import Heading from '../Heading';

export default storiesOf('Headings', module).addDecorator(host({
  align: 'center'
})).add('Default', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      Heading,
      { as: 'h1' },
      'H1. Bootstrap heading'
    ),
    React.createElement(
      Heading,
      { as: 'h2' },
      'H2. Bootstrap heading'
    ),
    React.createElement(
      Heading,
      { as: 'h3' },
      'H3. Bootstrap heading'
    ),
    React.createElement(
      Heading,
      { as: 'h4' },
      'H4. Bootstrap heading'
    ),
    React.createElement(
      Heading,
      { as: 'h5' },
      'H5. Bootstrap heading'
    ),
    React.createElement(
      Heading,
      { as: 'h6' },
      'H6. Bootstrap heading'
    )
  );
}).add('With sizes', function () {
  return React.createElement(
    Fragment,
    null,
    React.createElement(
      Heading,
      { as: 'h1', size: 'h6' },
      'H1. Bootstrap heading with H6 size'
    ),
    React.createElement(
      Heading,
      { as: 'h2', size: 'h5' },
      'H2. Bootstrap heading with H5 size'
    ),
    React.createElement(
      Heading,
      { as: 'h3', size: 'h4' },
      'H3. Bootstrap heading with H4 size'
    ),
    React.createElement(
      Heading,
      { as: 'h4', size: 'h3' },
      'H4. Bootstrap heading with H3 size'
    ),
    React.createElement(
      Heading,
      { as: 'h5', size: 'h2' },
      'H5. Bootstrap heading with H2 size'
    ),
    React.createElement(
      Heading,
      { as: 'h6', size: 'h1' },
      'H6. Bootstrap heading with H1 size'
    )
  );
});