import React from 'react';
import { storiesOf } from '@storybook/react';
import { host } from 'storybook-host';

import Pagination from '../Pagination';

export default storiesOf('Pagination', module).addDecorator(host({
  align: 'center'
})).add('Pagination', function () {
  return React.createElement(
    Pagination,
    null,
    React.createElement(
      Pagination.Item,
      null,
      React.createElement(
        Pagination.Link,
        { href: '#' },
        'Previous'
      )
    ),
    React.createElement(
      Pagination.Item,
      { active: true },
      React.createElement(
        Pagination.Link,
        { href: '#' },
        '1'
      )
    ),
    React.createElement(
      Pagination.Item,
      null,
      React.createElement(
        Pagination.Link,
        { href: '#' },
        '2'
      )
    ),
    React.createElement(
      Pagination.Item,
      null,
      React.createElement(
        Pagination.Link,
        { href: '#' },
        '3'
      )
    ),
    React.createElement(
      Pagination.Item,
      { disabled: true },
      React.createElement(
        Pagination.Link,
        { href: '#' },
        'Next'
      )
    )
  );
}).add('Pagination large', function () {
  return React.createElement(
    Pagination,
    { size: 'large' },
    React.createElement(
      Pagination.Item,
      null,
      React.createElement(
        Pagination.Link,
        { href: '#' },
        'Previous'
      )
    ),
    React.createElement(
      Pagination.Item,
      { active: true },
      React.createElement(
        Pagination.Link,
        { href: '#' },
        '1'
      )
    ),
    React.createElement(
      Pagination.Item,
      null,
      React.createElement(
        Pagination.Link,
        { href: '#' },
        '2'
      )
    ),
    React.createElement(
      Pagination.Item,
      null,
      React.createElement(
        Pagination.Link,
        { href: '#' },
        '3'
      )
    ),
    React.createElement(
      Pagination.Item,
      { disabled: true },
      React.createElement(
        Pagination.Link,
        { href: '#' },
        'Next'
      )
    )
  );
}).add('Pagination small', function () {
  return React.createElement(
    Pagination,
    { size: 'small' },
    React.createElement(
      Pagination.Item,
      null,
      React.createElement(
        Pagination.Link,
        { href: '#' },
        'Previous'
      )
    ),
    React.createElement(
      Pagination.Item,
      { active: true },
      React.createElement(
        Pagination.Link,
        { href: '#' },
        '1'
      )
    ),
    React.createElement(
      Pagination.Item,
      null,
      React.createElement(
        Pagination.Link,
        { href: '#' },
        '2'
      )
    ),
    React.createElement(
      Pagination.Item,
      null,
      React.createElement(
        Pagination.Link,
        { href: '#' },
        '3'
      )
    ),
    React.createElement(
      Pagination.Item,
      { disabled: true },
      React.createElement(
        Pagination.Link,
        { href: '#' },
        'Next'
      )
    )
  );
});