var _templateObject = _taggedTemplateLiteral(['\n  background-color: #17a2b8;\n'], ['\n  background-color: #17a2b8;\n']);

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

import React from 'react';
import { storiesOf } from '@storybook/react';
import { host } from 'storybook-host';
import { withKnobs, text, boolean } from '@storybook/addon-knobs/react';

import styled, { ThemeProvider } from 'styled-components';

import Progress from '../Progress';

var CustomProgressBar = styled(Progress.Bar)(_templateObject);

var customTheme = {
  progressHeight: '20px',
  progressBarBg: '#dc3545',
  progressBorderRadius: '2px'
};

export default storiesOf('Progress', module).addDecorator(withKnobs).addDecorator(host({
  align: 'center',
  width: 500
})).add('Basic', function () {
  return React.createElement(Progress, { width: text('Width', '30%') });
}).add('With children', function () {
  return React.createElement(
    Progress,
    null,
    React.createElement(Progress.Bar, {
      width: text('Width', '30%'),
      striped: boolean('Striped', false),
      animated: boolean('Animated', false)
    })
  );
}).add('With label', function () {
  return React.createElement(
    Progress,
    null,
    React.createElement(
      Progress.Bar,
      {
        width: text('Width', '60%'),
        striped: boolean('Striped', false),
        animated: boolean('Animated', false)
      },
      text('Text', '6%')
    )
  );
}).add('Striped', function () {
  return React.createElement(
    Progress,
    null,
    React.createElement(Progress.Bar, {
      width: text('Width', '45%'),
      striped: boolean('Striped', true),
      animated: boolean('Animated', false)
    })
  );
}).add('Animated', function () {
  return React.createElement(
    Progress,
    null,
    React.createElement(Progress.Bar, {
      width: text('Width', '65%'),
      striped: boolean('Striped', true),
      animated: boolean('Animated', true)
    })
  );
}).add('Multiple bars ', function () {
  return React.createElement(
    'div',
    { style: { width: 500 } },
    React.createElement(
      Progress,
      null,
      React.createElement(Progress.Bar, { width: text('Width', '25%') }),
      React.createElement(CustomProgressBar, { width: text('Width', '30%'), striped: true })
    )
  );
}).add('With custom theme ', function () {
  return React.createElement(
    ThemeProvider,
    { theme: customTheme },
    React.createElement(Progress, {
      width: text('Width', '70%'),
      striped: boolean('Striped', true),
      animated: boolean('Animated', true)
    })
  );
});