

// $FlowIssue
import stripUnit from 'polished/lib/helpers/stripUnit';

import { sassRgba } from '../sassRgba';
import { gray600, black } from './colors';
import { spacer } from './spacing';
import { borderWidth } from './components';

// Fonts
//
// Font, lineHeight, and color for body text, headings, and more.

export var fontFamilySansSerif = '-apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, sansSerif';
export var fontFamilyMonospace = 'Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace';
export var fontFamilyBase = fontFamilySansSerif;

export var fontSizeBase = '1rem'; // Assumes the browse, typically `16px`
export var fontSizeLg = '1.25rem';
export var fontSizeSm = '.875rem';

export var fontWeightNormal = 'normal';
export var fontWeightBold = 'bold';

export var fontWeightBase = fontWeightNormal;
export var lineHeightBase = 1.5;

export var h1FontSize = '2.5rem';
export var h2FontSize = '2rem';
export var h3FontSize = '1.75rem';
export var h4FontSize = '1.5rem';
export var h5FontSize = '1.25rem';
export var h6FontSize = '1rem';

export var headingsMarginBottom = spacer / 2 + 'rem';
export var headingsFontFamily = 'inherit';
export var headingsFontWeight = 500;
export var headingsLineHeight = 1.1;
export var headingsColor = 'inherit';

export var display1Size = '6rem';
export var display2Size = '5.5rem';
export var display3Size = '4.5rem';
export var display4Size = '3.5rem';

export var display1Weight = 300;
export var display2Weight = 300;
export var display3Weight = 300;
export var display4Weight = 300;
export var displayLineHeight = headingsLineHeight;

export var leadFontSize = '1.25rem';
export var leadFontWeight = 300;

export var smallFontSize = '80%';

export var textMuted = gray600;

export var blockquoteSmallColor = gray600;
export var blockquoteFontSize = stripUnit(fontSizeBase) * 1.25 + 'rem';

export var hrBorderColor = sassRgba(black, 0.1);
export var hrBorderWidth = borderWidth;

export var markPadding = '.2em';

export var dtFontWeight = fontWeightBold;

export var kbdBoxShadow = 'inset 0 -.1rem 0 ' + sassRgba(black, 0.25);
export var nestedKbdFontWeight = fontWeightBold;

export var listInlinePadding = '5px';

export var markBg = '#fcf8e3';